/* Copyright (C) 2010, Alexander Graf <agraf@znc.in>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#pragma once

#include <stdarg.h>

/* stdio */
extern int vsprintf(char *, const char *, va_list);
extern int sprintf(char *, const char *, ...);
extern int vprintf(const char *, va_list);
extern int printf(const char *, ...);
extern int puts(const char *);

/* string */
extern void *memcpy(void *, const void *, unsigned int);
extern void *memset(void *, int, unsigned int);
extern int strcmp(const char *, const char *);
extern int strncmp(const char *, const char *, unsigned int n);
extern char *strchr(const char *, int);
extern unsigned int strlen(const char *);

/* stdlib */
extern long strtol(const char *str, char **endptr, int base);
extern void *malloc(unsigned int);
extern void free(void *);
extern void mm_init();
#define alloca(s)	__builtin_alloca(s)

/* limits */
#define	LONG_MAX	0x7fffffffL
#define	LONG_MIN	(-0x7fffffffL - 1)

/* ctype */
#define isspace(c)	((c) == '\t' || (c) == '\n' || (c) == '\v' ||	\
			 (c) == '\f' || (c) == '\r' || (c) == ' ')
#define isascii(c)	((c) < 0x80)
#define isdigit(c)	('0' <= (c) && (c) <= '9')
#define isupper(c)	('A' <= (c) && (c) <= 'Z')
#define islower(c)	('a' <= (c) && (c) <= 'z')
#define isalpha(c)	(isupper(c) || islower(c))

/* not in libc */

/* description of last error */
extern const char *errmsg;

#define blocks(s, b)	(((s) + (b) - 1) / (b))
#define square(x)	((x)*(x))
#define min(a, b)	((a) < (b) ? (a) : (b))
#define max(a, b)	((a) > (b) ? (a) : (b))
