/* Copyright (C) 2009, Alexander Graf <agraf@znc.in>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#pragma once

/* defines for MMC access through the SPI interface by using software SPI
 * (direct GPIO access) */

#define CS	(1 << 12)	/* MMC pin 1 - Chip Select (active-low) */
#define DI	(1 << 3)	/* MMC pin 2 - Data In */
				/* MMC pin 3 - Ground */
				/* MMC pin 4 - Power Supply */
#define CLK	(1 << 2)	/* MMC pin 5 - Serial Clock (active-low) */
				/* MMC pin 6 - Ground */
#define DO	(1 << 6)	/* MMC pin 7 - Data Out */

/* GPIO registers */
#define GPIO_BASE	0x3fffc000
#define IODIR		(*(volatile unsigned int *) (GPIO_BASE + 0x20))
#define IOPIN		(*(volatile unsigned int *) (GPIO_BASE + 0x34))
#define IOSET		(*(volatile unsigned int *) (GPIO_BASE + 0x38))
#define IOCLR		(*(volatile unsigned int *) (GPIO_BASE + 0x3c))

static inline int mmc_card_inserted(void)
{
	return !(*(volatile int *) 0x3fffc014 & (1 << 11));
}
