/* Copyright (C) 2009, Alexander Graf <agraf@znc.in>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA. */

#pragma once

#include "cpu.h"

#define EXTRAM_SIZE	(8 << 20)

/* cycles for specified nanoseconds */
#define NS(x)		((x) * CPU_CLOCK / 1000000000)

#define R_RS		1
#define R_RASCAS	(3 | 3 << 8)
#define R_tRP		NS(60)
#define R_tRAS		NS(120)
#define R_tSREX		5
#define R_tAPR		2
#define R_tDAL		5
#define R_tWR		3
#define R_tRC		NS(160)
#define R_tRFC		11
#define R_tXSR		5
#define R_tRRD		NS(50)
#define R_tMRD		8
#define R_ADRMAP	(2 << 7 | 1 << 9 | 1 << 14)
